
#ifndef PORYGONLANG_BOUNDFUNCTIONDECLARATIONSTATEMENT_HPP
#define PORYGONLANG_BOUNDFUNCTIONDECLARATIONSTATEMENT_HPP

#include <memory>
#include "BoundStatement.hpp"

class BoundFunctionDeclarationStatement : public BoundStatement{
    BoundVariableKey* _key;
    std::shared_ptr<BoundBlockStatement> _block;
    std::shared_ptr<FunctionScriptType> _type;
public:
    BoundFunctionDeclarationStatement(std::shared_ptr<FunctionScriptType> type, BoundVariableKey* key, BoundBlockStatement* block){
        _key = key;
        _block = shared_ptr<BoundBlockStatement>(block);
        _type = type;
    }

    ~BoundFunctionDeclarationStatement() final{
        delete _key;
    }

    BoundStatementKind GetKind() final{
        return BoundStatementKind ::FunctionDeclaration;
    }

    BoundVariableKey* GetKey(){
        return _key;
    }

    std::shared_ptr<BoundBlockStatement> GetBlock(){
        return _block;
    }

    std::shared_ptr<FunctionScriptType> GetType(){
        return _type;
    }
};

#include "BoundStatement.hpp"

#endif //PORYGONLANG_BOUNDFUNCTIONDECLARATIONSTATEMENT_HPP
