#import "EvalValue.hpp"
#include <cstring>

extern "C" {
    TypeClass GetEvalValueTypeClass(EvalValue* v){
        return v->GetType().get()->GetClass();
    }

    ScriptType* GetEvalValueType(EvalValue* v){
        return v->GetType().get();
    }

    int64_t EvaluateEvalValueInteger(EvalValue* v){
        return v->EvaluateInteger();
    }

    double EvaluateEvalValueFloat(EvalValue* v){
        return v->EvaluateFloat();
    }

    bool EvaluateEvalValueBool(EvalValue* v){
        return v->EvaluateBool();
    }

    const char* EvaluateEvalValueString(EvalValue* v){
        return v->EvaluateString() -> c_str();
    }

}

#ifdef TESTS_BUILD
#include <catch.hpp>
#include "../src/Script.hpp"


TEST_CASE( "Evaluate String", "[integration]" ) {
    auto script = Script::Create("\"foo bar\"");
    REQUIRE(!script->Diagnostics -> HasErrors());
    script->Evaluate();
    auto lastValue = script->GetLastValue();
    REQUIRE(std::strcmp(EvaluateEvalValueString(lastValue), "foo bar") == 0);
    delete script;
}


#endif
