#include <utility>

#ifndef PORYGONLANG_SCRIPTFUNCTIONEVALVALUE_HPP
#define PORYGONLANG_SCRIPTFUNCTIONEVALVALUE_HPP

#include <memory>
#include <utility>
#include "../../ScriptType.hpp"
#include "EvalValue.hpp"
#include "../../Binder/BoundStatements/BoundStatement.hpp"
#include "../Evaluator.hpp"


class ScriptFunctionEvalValue : public EvalValue{
    std::shared_ptr<BoundBlockStatement> _innerBlock;
    std::shared_ptr<FunctionScriptType> _type;
public:
    explicit ScriptFunctionEvalValue(std::shared_ptr<BoundBlockStatement> innerBlock, std::shared_ptr<FunctionScriptType> type)
    : _type(std::move(type))
    {
        _innerBlock = std::move(innerBlock);
    }

    std::shared_ptr<ScriptType> GetType() final{
        return _type;
    }

    shared_ptr<EvalValue> Clone() final{
        return make_shared<ScriptFunctionEvalValue>(_innerBlock, _type);
    }


    bool operator ==(EvalValue* b) final{
        if (b->GetType()->GetClass() != TypeClass::Function)
            return false;
        return this->_innerBlock == ((ScriptFunctionEvalValue*)b)->_innerBlock;
    };

    std::shared_ptr<BoundBlockStatement> GetInnerBlock(){
        return _innerBlock;
    }

};


#endif //PORYGONLANG_SCRIPTFUNCTIONEVALVALUE_HPP
