
#ifndef PORYGONLANG_EVALUATIONSCOPE_HPP
#define PORYGONLANG_EVALUATIONSCOPE_HPP

#include <unordered_map>
#include <vector>
#include "../EvalValues/EvalValue.hpp"

class EvaluationScope {
    unordered_map<int, shared_ptr<EvalValue>>* _scriptScope;
    vector<unordered_map<int, shared_ptr<EvalValue>>> _localScope;
    int _currentScope;
public:
    explicit EvaluationScope(unordered_map<int, shared_ptr<EvalValue>>* scriptVariables, int deepestScope);
    ~EvaluationScope() = default;

    void CreateVariable(int scope, int id, shared_ptr<EvalValue> value);
    void SetVariable(int scope, int id, shared_ptr<EvalValue> value);
    void OuterScope();
    void InnerScope();
    shared_ptr<EvalValue> GetVariable(int scope, int id);
};


#endif //PORYGONLANG_EVALUATIONSCOPE_HPP
