#ifndef PORYGONLANG_LEXER_HPP
#define PORYGONLANG_LEXER_HPP
#include <string>
#include <vector>
#include "Token.hpp"
#include "../Script.hpp"

using namespace std;

class Lexer {
    string _scriptString;
#ifdef TESTS_BUILD
public:
#endif
    unsigned int Position;
    char Peek();
    char Next();
    IToken* LexNext(char c);
    IToken* LexNumber(char c);
    IToken* LexIdentifierOrKeyword();
    IToken* LexString(char c);
public:
    Script* ScriptData;

    vector<IToken*> Lex();
    explicit Lexer(string scriptString, class Script* script);

};


#endif //PORYGONLANG_LEXER_HPP
