
#ifndef PORYGONLANG_HASHEDSTRING_HPP
#define PORYGONLANG_HASHEDSTRING_HPP

#include <string>

class HashedString{
    const int _hash;
public:
    explicit HashedString(const std::string& s) : _hash(ConstHash(s.c_str())){
    }
    explicit HashedString(char const *input) : _hash(ConstHash(input)){
    }

    static unsigned constexpr ConstHash(char const *input) {
        return *input ?
               static_cast<unsigned int>(*input) + 33 * ConstHash(input + 1) :
               5381;
    }

    const int GetHash(){
        return _hash;
    }

    bool operator==(const HashedString& b) const{
        return _hash == b._hash;
    }
    bool operator!=(const HashedString& b) const{
        return _hash != b._hash;
    }
};

#endif //PORYGONLANG_HASHEDSTRING_HPP
